--- callbacks.c.orig	2003-11-22 16:19:48.000000000 +0100
+++ callbacks.c	2005-09-12 23:53:46.000000000 +0200
@@ -1372,7 +1372,7 @@
   GdkBitmap *mask;
   v24_port_t *port = NULL;
   gint stop = 0;
-  gfloat i = 1.0;
+  int i = 1;
   gchar *tmp;
   gchar **entry;
   gchar *entrys[3];
@@ -1418,8 +1418,8 @@
       //strncpy (buffer, buffer1, strlen(buffer));
       g_strstrip (buffer1);
 
-      gtk_progress_set_value ((GtkProgress *) progress_bar, i);
-      formatstring = g_strdup_printf ("entry #%d", (gint) i);
+      gtk_progress_set_value ((GtkProgress *) progress_bar, i%2);
+      formatstring = g_strdup_printf ("entry #%d", i);
       gtk_label_set_text (GTK_LABEL (label), formatstring);
       
       while (gtk_events_pending())
@@ -1427,13 +1427,18 @@
       
       if (strstr (buffer1, "+CPBR:")) {
 	entry = g_strsplit (buffer1 + 6, ",", 3);
+	if (entry[3][strlen (entry[3] + 1) - 2] != '/') {
+	    g_print ("Bad record: %s\n", buffer1);
+	    continue;
+	}
+
 	entrys[0] = g_strdup (entry[0]);
 	entrys[1] = g_strndup (entry[3] + 1, strlen (entry[3] + 1) - 3);
 	
 	entrys[1] = convert_from_gsm (entrys[1]);
 	style = gtk_widget_get_style (mainwindow);
 	tmp = g_strdup_printf ("type%d", (gint) i - 1);
-	
+
 	switch (entry[3][strlen (entry[3] + 1) - 1]) {
 	  case 'H' :
 	    pixmap = gdk_pixmap_create_from_xpm_d (mainwindow->window,  &mask,
@@ -1466,7 +1471,7 @@
 	    gtk_object_set_data (GTK_OBJECT (user_data), tmp, "F");
 	    break;
 	  default :
-	    g_print ("%c\n", entry[3][strlen (entry[3] + 1) - 1]);
+	    g_print ("Error, unknown record type: %c\n", entry[3][strlen (entry[3] + 1) - 1]);
 	    break;
 	}
 	
@@ -1476,16 +1481,19 @@
 	  entrys[2] = g_strdup_printf ("+%s", entrys[2]);
 	
 	gtk_clist_append (GTK_CLIST (user_data), entrys);
-	//      g_print ("%s\n", entrys[1]);
+
 	gtk_clist_set_pixtext (GTK_CLIST (user_data), (gint) i - 1, 1,
 			       entrys[1], 2, pixmap, mask);
-      }
-      if (strcasecmp (buffer, "OK\r\n") == 0)
+
+        i++;
+      } else if (strcasecmp (buffer, "OK\r\n") == 0) {
 	stop = 1;
-      if (strcasecmp (buffer, "ERROR\r\n") == 0)
+      } else if (strcasecmp (buffer, "ERROR\r\n") == 0) {
 	stop = 1;
-      
-      i++;
+      } else if (strcasecmp (buffer, "\r\n") == 0) {
+      } else {
+        g_print("Bad input (+CPBR: required): %s",buffer);
+      }
     }
     
     v24ClosePort (port);
